\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\\ This program provides the computational steps to prove Section 8.2


def to_square(r):
	B = matrix_length()
	return B*vector([r.trace()/2,(r-r.norm()/r)/(2*x)])


def matrix_length():
	ax = HZ1.trace()/2; ay = (HZ1-HZ1.norm()/HZ1)/(2*x)
	bx = HZ2.trace()/2; by = (HZ2-HZ2.norm()/HZ2)/(2*x)
	return matrix([[ax,bx],[ay,by]]).inverse()

def initialization_coordinates(D,i=1):
	global K, phi, x, Mred,WC1,HC1,WZ1,HZ1,WC2,HC2,WZ2,HZ2,a1,a2,b1,b2
	K.<x> = QuadraticField(D)
	l = K.embeddings(RR)
	m = [(l[k](x),k) for k in xrange(2)]
	phi = l[max(m)[1]]

	MredD2_1 = matrix([[72,48],[24,18]]);
	MredD3_1 = matrix([[72,24],[12,6]]); MredD3_2 = matrix([[72,24],[48,18]]); MredD3_3 = matrix([[36,12],[30,12]])
	MredD33_1 = matrix([[6,24],[12,54]]); MredD33_2 = matrix([[6,24],[3,18]]); MredD33_3 = matrix([[3,6],[3,0]])

	WHD2_1 = [1, 1, 48*x + 72, -1/12*x + 1/8, 1/2*x, 2*x, 36*x + 48, 1/4*x - 1/3]

	WHD3_1 = [1, 1, 24*x + 48, -1/24*x + 1/12, 1/2*x - 1/2, 2*x - 2, 12*x + 12, 1/4*x - 5/12]
	WHD3_2 = [1, 1, 96*x + 168, -1/24*x + 1/12, 1/2*x + 1/2, 2*x + 2, 36*x + 60, 1/4*x - 5/12]
	WHD3_3 = [1, 1, 20*x + 36, -1/12*x + 1/6, x, 2/3*x, 8*x + 12, 1/2*x - 5/6]

	WHD33_1 = [1, 1, 2*x + 12, -1/6*x + 1, 1/2*x + 3/2, 1/6*x + 1/2, 9*x + 51, 1/12*x - 5/12]
	WHD33_2 = [1, 1, 1/2*x + 9/2, -1/6*x + 1, 1/2*x - 3/2, 1/6*x - 1/2, 3*x + 15, 1/12*x - 5/12]
	WHD33_3 = [1, 1, 1/2*x + 3/2, 1/12*x - 1/4, 1/2*x - 3/2, 1/6*x - 1/2, 6, -1/12*x + 7/12]

	[WC1,HC1,WZ1,HZ1,WC2,HC2,WZ2,HZ2] = eval("WHD"+str(D)+"_"+str(i))
	Mred = eval("MredD"+str(D)+"_"+str(i))

	# Give the number of squares for horizontal/vertical cylinders
	[a1,a2,b1,b2] = [ Mred[0][0]+Integer(Mred[0][1]/2),Mred[1][0]*2+Mred[1][1] , Mred[0][0]+Mred[1][0],Mred[0][1]+Mred[1][1] ]
	return "END"

def initialization_topological_models(model):
	global slit_squares, lengths, possible_twists, surface_prym, range_gamma
	# CYLINDERS 1-3-2: SQUARES 1--a1; a1+1--2*a1; 2*a1+1--2*a1+a2
	cylinders1 = [((0,2,3),(4,0)),((1,5),(2,3,1)), ((4,),(5,))]
	cylinders2 = [((0,5,3),(2,0)),((1,2),(4,3,1)), ((4,),(5,))] 
	cylinders3 = [((0,1,2),(4,)),((3,),(1,5,0)), ((4,5),(2,3))] 
	cylinders4 = [((0,3),(4,0)), ((1,4),(5,1)),((2,5),(3,2))] 
	cylinders5 = [((0,2),(5,3)), ((1,3),(4,2)),((4,5),(1,0))] 
	cylinders6 = [((0,3),(2,)), ((1,),(5,3)),((2,5,4),(4,1,0))]
	cylinders7 = [((0,),(2,)), ((1,),(3,)),((2,4,3,5),(5,1,4,0))]
	cylinders8 = [((0,),(4,)), ((1,),(3,)),((2,3,4,5),(1,5,2,0))]

	lengths1 = lambda gamma: [a1-a2,a1-a2,gamma,a2-gamma,a2,a2]
	lengths2 = lambda gamma: [gamma,gamma,a1-gamma,a1-a2-gamma,a2,a2]
	lengths3 = lambda gamma: [gamma,2*a1-a2-gamma,a2-a1,a1,a1,a2-a1]
	lengths4 = lambda gamma: [a1-gamma, a1-gamma,a2-gamma,gamma,gamma,gamma]
	lengths5 = lambda gamma: [a1-gamma,a2-a1+gamma,gamma,2*a1-a2-gamma,a1-gamma,a2-a1+gamma]
	#lengths5 = lambda gamma: [a1-gamma,a2-a1+gamma,gamma,2*a1-a2+gamma,a1-gamma,a2-a1+gamma]
	lengths6 = lambda gamma: [gamma,a1,a1,a1-gamma,a2-a1-gamma,gamma]
	lengths7 = lambda gamma: [a1,a1,a1,a1,gamma,a2-2*a1-gamma]
	lengths8 = lambda gamma: [a1,a1,gamma,a1,a1,a2-2*a1-gamma]

	slit1 = lambda gamma: [a1-a2+1..a1-a2+gamma]
	slit2 = lambda gamma: [1..gamma]
	slit3 = lambda gamma: [1..gamma]
	slit4 = lambda gamma: [a1-gamma+1..a1]
	slit5 = lambda gamma: [a1-gamma+1..a1]
	#slit5 = lambda gamma: [1..gamma]
	slit6 = lambda gamma: [1..gamma]
	slit7 = lambda gamma: [3*a1+1..3*a1+gamma]
	slit8 = lambda gamma: [2*a1+1..2*a1+gamma]

	twist1 = lambda gamma: [0]
	twist2 = lambda gamma: [0]
	twist3 = lambda gamma: [0,1,WC2-1]
	twist4 = lambda gamma: [WC2-gamma,gamma]
	twist5 = lambda gamma: [1-gamma,WC2-1+gamma]
	#twist5 = lambda gamma: [gamma,1-gamma]
	twist6 = lambda gamma: [1+gamma,1-gamma,WC2-1-gamma]
	twist7 = lambda gamma: [1+gamma,2+gamma,WC2-2-gamma]
	twist8 = lambda gamma: [gamma+2,gamma,WC2-1-gamma,3-WC2+gamma]

	range1 = [1..a2-1]
	range2 = [1..min(a2-1,a1-a2-1)]
	range3 = [1..min(a1,2*a1-a2)-1]
	range4 = [1..min(a1,a2)-1]
	range5 = [max(a1-a2+1,1)..min(a1,2*a1-a2)-1]
	#range5 = [max(a2-a1,0)+1..min(a2,a1)-1]
	range6 = [1..min(a2-a1,a1)-1]
	range7 = [1..a2-2*a1-1]
	range8 = [1..a2-2*a1-1]

	surface_prym = CylinderDiagram(eval("cylinders"+str(model)))
	lengths = eval("lengths"+str(model))
	slit_squares = eval("slit"+str(model))
	possible_twists = eval("twist"+str(model))
	range_gamma = eval("range"+str(model))
	return "END"

def initialization(D,i=1,model=1):
	initialization_coordinates(D,i)
	if model==1 and not a2<a1: print "MODEL NOT COMPATIBLE WITH a1,a2"; return False
	if model==2 and not a2<a1: print "MODEL NOT COMPATIBLE WITH a1,a2"; return False
	if model==3 and not (a1<a2 and a2<2*a1): print "MODEL NOT COMPATIBLE WITH a1,a2"; return False
	if model==5 and not a2<2*a1: print "MODEL NOT COMPATIBLE WITH a1,a2"; return False
	if model==6 and not a1<a2: print "MODEL NOT COMPATIBLE WITH a1,a2"; return False
	if model==7 and not 2*a1<a2: print "MODEL NOT COMPATIBLE WITH a1,a2"; return False
	if model==8 and not 2*a1<a2: print "MODEL NOT COMPATIBLE WITH a1,a2"; return False
	initialization_topological_models(model)
	return True

#initialization(3,1,6)


def surface_check(parameters=[1,1,0]):
	[gamma,t1,t2] = parameters
	origami_prym = surface_prym.cylcoord_to_origami(lengths(gamma),[1,1,1],[t1,t1,t2])
	print origami_prym.cylinder_diagram()
	print origami_prym.mirror().cylinder_diagram()
	return origami_prym.orientation_data()
#******************************************************************************************************************************
#******************************************************************************************************************************
#******************************************************************************************************************************
# GIVEN PARAMETERS, CHECK THAT THE INTERSECTION MATRIX IS THE GOOD ONE

def is_good_parameters(gamma,t1,t2):
	origami_prym = surface_prym.cylcoord_to_origami(lengths(gamma),[1,1,1],[t1,t1,t2])
	V = origami_prym.u(); cyl_vert = V.cycles() 	
	if not len(cyl_vert) == 3: return [False,0]
	cyl = [b2,b1,b1]; cyl.sort();
	cyl2 = [c.order() for c in cyl_vert]; cyl2.sort()
	if not cyl == cyl2: return [False,0]

	if cyl_vert[0].order() == b2: Z1=cyl_vert[1]; Z2=cyl_vert[0]
	if cyl_vert[1].order() == b2: Z1=cyl_vert[0]; Z2=cyl_vert[1]
	if cyl_vert[2].order() == b2: Z1=cyl_vert[0]; Z2=cyl_vert[2]
	Z1 = list(eval(Z1.cycle_string())); Z2 = list(eval(Z2.cycle_string()));
	# check the REDUCED INTERSECTION MATRIX
	[M11,M12,M21,M22] = [0,0,0,0]

	for i in [1..a1]:
		if i in Z2: M12 = M12 + 1
		else: M11 = M11 + 1 # COMPUTE THE SUM M11 + M13!!

	for i in [2*a1+1..2*a1+a2]:
		if i in Z1: M21 = M21 + 1
		if i in Z2: M22 = M22 + 1

	#for i in Z2:
	#	if i>2*a1: M22 = M22 + 1
	#	if i<a1+1: M21 = M21 + 1

	#for i in Z1:
	#	if i>2*a1: M12 = M12 + 1
	#	if i<a1+1 or (i>a1 and i<2*a1+1): M11 = M11 + 1 # COMPUTE THE SUM M11 + M13!!

	if matrix([[M11,2*M12],[M21,M22]])==Mred:
		if len((origami_prym.mirror()).cylinder_diagram().cylinders()) == 3: return [True,Z2]
	return [False,0]



def find_arithmetic_surfaces():
	surfaces = [ ]
	print range_gamma
	for gamma in range_gamma:
		print gamma
		for t1 in xrange(a1):
			#[check,Z] = is_good_parameters(gamma,t1,0)
			#if check: surfaces.append([gamma,t1,0,Z])
			for t2 in xrange(a2):#[a2-gamma,gamma]:#
				[check,Z] = is_good_parameters(gamma,t1,t2)
				if check: surfaces.append([gamma,t1,t2,Z])
	return surfaces


#******************************************************************************************************************************
#******************************************************************************************************************************
#******************************************************************************************************************************
# GIVEN A LIST L OF SQUARES AND CYLINDER Z2, RETURN THE SQUARES THAT ARE IN Z2 (B) AND IN Z1,Z3 (i.e. NOT IN Z2) (A)
def count_squares(L,Z):
	[A,B] = [0,0]
	for i in L:
		if i in Z: B=B+1
		else: A=A+1
	return [A,B]

# COMPUTES THE LENGTHS OF TWISTS AND SLIT IN TERMS OF SQUARES
def combinatoric_to_length(parameters):
	[gamma,t1,t2,Z] = parameters
	#saddle_0 = count_squares([1..gamma],Z); print saddle_0; print "saddle_0" + str(HZ1*saddle_0[0]+HZ2*saddle_0[1])
	#saddle_1 = count_squares([a1+1..2*a1],Z); print saddle_1; print "saddle_1" + str( HZ1*saddle_1[0]+HZ2*saddle_1[1])
	#saddle_4 = count_squares([3*a1+gamma+1..2*a1+a2],Z); print saddle_4; print "saddle_4" + str( HZ1*saddle_4[0]+HZ2*saddle_4[1])
	#saddle_2 = count_squares([1..a1],Z); print saddle_2; print "saddle_2" + str( HZ1*saddle_2[0]+HZ2*saddle_2[1])
	#saddle_3 = count_squares([gamma+1..a1],Z); print saddle_3; print "saddle_3" + str( HZ1*saddle_3[0]+HZ2*saddle_3[1])
	#saddle_5 = count_squares([2*a1+a2-gamma+1..2*a1+a2],Z); print "saddle_5" + str( saddle_5)

	slit = count_squares(slit_squares(gamma),Z)
	twist_1 = [0,0]; twist_2 = [0,0]
	if t1 > 0: twist_1 = count_squares([1..t1],Z)
	if t2 > 0: twist_2 = count_squares([2*a1+1..2*a1+t2],Z)
	[wA,wB] = [HZ1,HZ2]
	return [wA*s[0]+wB*s[1] for s in [slit,twist_1,twist_2]]
    

def combinatoric_to_surface(parameters):
        [gamma,t1,t2,Z] = parameters
	sur = combinatoric_to_length(parameters)
	# CHECK THAT THE VERTICAL DIRECTION IS ALSO GOOD
	if sur[-1] in possible_twists(sur[0]): return [sur,[gamma,t1,t2]]
	return [ ]

# sur is [slit,twist_1,twist_2]
def surface_to_prototype(sur):
	if sur == [ ]: return [ ]
	#sur_without_t1 = [sur[0],sur[2] + (WC1-sur[1])*HC2/HC1]  #eliminate_twists_t1
	sur_without_t2 = [sur[0],sur[1] + (WC2-sur[2])*HC1/HC2]  #eliminate_twists_t2
	[slit,twist_t1] = [e*HC2/WC2 for e in sur_without_t2] # HENCE twist_t1 is in Q
	#return [slit,twist_t1]
	p = twist_t1.numerator(); q = twist_t1.denominator()
	# PROTOTYPE w,h,t,lambda
	#[w,h,t,s] = [2*q*WC1*HC2/WC2,2*q*HC1,2*p,q*slit] # w MAY BE IN Q AND NOT IN N
        [w,h,t,s] = [q*WC1*HC2/WC2,q*HC1,p,q*slit] # w MAY BE IN Q AND NOT IN N
	a = w.numerator(); b = w.denominator()
	[w,h,t,s] =  [a,b*h,b*t,b*s]
	t = Integer(mod(t,gcd(Integer(w),Integer(h))))
	d = gcd([w,h,t])
	Lambda = HC2*q*b/d
        e = sqrt(Lambda.minpoly().discriminant()-8*(w/d)*(h/d))
	return [w/d,h/d,t/d,s/d/Lambda,Lambda,Lambda.minpoly().discriminant(),e]



def final(listofsur):
	listofproto = [ ]
	listofprotoandparameters = [ ]
	for parameters in listofsur:
		p = combinatoric_to_surface(parameters)
		if not p==[ ]:
			[sur,[gamma,t1,t2]] = p
			proto = surface_to_prototype(sur)
			if not proto in listofproto and not proto==[]:
				listofproto.append(proto)
				listofprotoandparameters.append([proto,[gamma,t1,t2]])
	return listofprotoandparameters


def final_metric(listofsur):
	listofparameters = [ ]
	for parameters in listofsur:
		p = combinatoric_to_surface(parameters)
		if not p==[ ]:
			#[sur,[gamma,t1,t2]] = p
			if not p in listofparameters:
				listofparameters.append(p)
	return listofparameters


def final2(listofsur):
	for parameters in listofsur:
		sur = combinatoric_to_surface(parameters)
		if not sur==[]:
			print [sur[0][0],sur[0][1],sur[0][2],sur[1]]
			#print [to_square(sur[0][0]),to_square(sur[0][1]),sur[1]]
			#print [surface_to_prototype(sur[0]),sur[1]]
	return "END"


def to_discriminant(listofproto):
	for p in listofproto:
		P = p[0][-2].minpoly()
		print [p,P.discriminant()]
	return "END"


def solve_problem(D,i,model):
	if not initialization(D,i,model): return "END"
	listofsur = find_arithmetic_surfaces()
	listofproto = final(listofsur)
	print "Candidates for topological surfaces: " + str(len(listofsur))
	print
	print "The discriminant is " + str(D) + " and the case is i="+str(i)
	print
	print "The model is "+str(model)+" and there are " + str(len(listofproto)) + " solutions given by:"
	return to_discriminant(listofproto)



# GALOIS CONJUGATE
def galois(r):
    if r in QQ: return r
    return r.norm()/r